---
sidebar_label: s3
---

# dagger.io/aws/s3

## #Put

S3 file or Directory upload

### #Put Inputs

| Name                 | Type                | Description                                                      |
| -------------        |:-------------:      |:-------------:                                                   |
|*config.region*       | `string`            |AWS region                                                        |
|*config.accessKey*    | `dagger.#Secret`    |AWS access key                                                    |
|*config.secretKey*    | `dagger.#Secret`    |AWS secret key                                                    |
|*target*              | `string`            |Target S3 URL (eg. s3://\<bucket-name\>/\<path\>/\<sub-path\>)    |
|*contentType*         | `*"" \| string`     |Object content type                                               |
|*always*              | `*true \| bool`     |Always write the object to S3                                     |

### #Put Outputs

| Name             | Type              | Description                     |
| -------------    |:-------------:    |:-------------:                  |
|*url*             | `string`          |URL of the uploaded S3 object    |

## #Sync

S3 Sync

### #Sync Inputs

| Name                 | Type                  | Description                                                                            |
| -------------        |:-------------:        |:-------------:                                                                         |
|*config.region*       | `string`              |AWS region                                                                              |
|*config.accessKey*    | `dagger.#Secret`      |AWS access key                                                                          |
|*config.secretKey*    | `dagger.#Secret`      |AWS secret key                                                                          |
|*source*              | `dagger.#Artifact`    |Source Artifact to upload to S3                                                         |
|*target*              | `string`              |Target S3 URL (eg. s3://\<bucket-name\>/\<path\>/\<sub-path\>)                          |
|*delete*              | `*false \| bool`      |Files that exist in the destination but not  in  the source are deleted during sync.    |
|*contentType*         | `*"" \| string`       |Object content type                                                                     |
|*always*              | `*true \| bool`       |Always write the object to S3                                                           |

### #Sync Outputs

| Name             | Type              | Description                     |
| -------------    |:-------------:    |:-------------:                  |
|*url*             | `string`          |URL of the uploaded S3 object    |
